Index: boot/generic/include/gzip.h
===================================================================
--- boot/generic/include/gzip.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ boot/generic/include/gzip.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -30,6 +30,9 @@
 #define LIBCOMPRESS_GZIP_H_
 
+#include <stdbool.h>
 #include <stddef.h>
-size_t gzip_size(const void *, size_t);
+
+extern bool gzip_check(const void *, size_t);
+extern size_t gzip_size(const void *, size_t);
 extern int gzip_expand(const void *, size_t, void *, size_t);
 
Index: boot/generic/src/gzip.c
===================================================================
--- boot/generic/src/gzip.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ boot/generic/src/gzip.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -63,14 +63,22 @@
 } __attribute__((packed)) gzip_footer_t;
 
-size_t gzip_size(const void *src, size_t srclen)
+/** Check GZIP signature
+ *
+ * Checks whether the source buffer start with a GZIP signature.
+ *
+ * @param[in] src    Source data buffer.
+ * @param[in] srclen Source buffer size (bytes).
+ *
+ * @return True if GZIP signature found.
+ * @return False if no GZIP signature found.
+ *
+ */
+bool gzip_check(const void *src, size_t srclen)
 {
+	if ((srclen < (sizeof(gzip_header_t) + sizeof(gzip_footer_t))))
+		return false;
+
 	gzip_header_t header;
-	gzip_footer_t footer;
-
-	if ((srclen < sizeof(header)) || (srclen < sizeof(footer)))
-		return 0;
-
 	memcpy(&header, src, sizeof(header));
-	memcpy(&footer, src + srclen - sizeof(footer), sizeof(footer));
 
 	if ((header.id1 != GZIP_ID1) ||
@@ -78,5 +86,28 @@
 	    (header.method != GZIP_METHOD_DEFLATE) ||
 	    ((header.flags & (~GZIP_FLAGS_MASK)) != 0))
+		return false;
+
+	return true;
+}
+
+/** Get uncompressed size
+ *
+ * Note that the uncompressed size is read from the GZIP footer
+ * (and not calculated by acutally decompressing the GZip archive).
+ * Thus the source of the GZip archive needs to be trusted.
+ *
+ * @param[in]  src    Source data buffer.
+ * @param[out] srclen Source buffer size (bytes).
+ *
+ * @return Uncompressed size.
+ *
+ */
+size_t gzip_size(const void *src, size_t srclen)
+{
+	if (!gzip_check(src, srclen))
 		return 0;
+
+	gzip_footer_t footer;
+	memcpy(&footer, src + srclen - sizeof(footer), sizeof(footer));
 
 	return uint32_t_le2host(footer.size);
@@ -85,6 +116,6 @@
 /** Expand GZIP compressed data
  *
- * The routine allocates the output buffer based
- * on the size encoded in the input stream. This
+ * The routine compares the output buffer size with
+ * the size encoded in the input stream. This
  * effectively limits the size of the uncompressed
  * data to 4 GiB (expanding input streams that actually
@@ -108,20 +139,14 @@
 int gzip_expand(const void *src, size_t srclen, void *dest, size_t destlen)
 {
+	if (!gzip_check(src, srclen))
+		return EINVAL;
+
+	/* Decode header and footer */
+
 	gzip_header_t header;
+	memcpy(&header, src, sizeof(header));
+
 	gzip_footer_t footer;
-
-	if ((srclen < sizeof(header)) || (srclen < sizeof(footer)))
-		return EINVAL;
-
-	/* Decode header and footer */
-
-	memcpy(&header, src, sizeof(header));
 	memcpy(&footer, src + srclen - sizeof(footer), sizeof(footer));
-
-	if ((header.id1 != GZIP_ID1) ||
-	    (header.id2 != GZIP_ID2) ||
-	    (header.method != GZIP_METHOD_DEFLATE) ||
-	    ((header.flags & (~GZIP_FLAGS_MASK)) != 0))
-		return EINVAL;
 
 	if (destlen != uint32_t_le2host(footer.size))
Index: boot/generic/src/payload.c
===================================================================
--- boot/generic/src/payload.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ boot/generic/src/payload.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -61,12 +61,6 @@
 {
 	char *e = (char *) ext(s);
-	if (e != NULL && str_cmp(e, ".gz") == 0)
+	if ((e != NULL) && (str_cmp(e, ".gz") == 0))
 		*e = '\0';
-}
-
-static bool isgzip(const char *s)
-{
-	const char *e = ext(s);
-	return e != NULL && str_cmp(e, ".gz") == 0;
 }
 
@@ -82,17 +76,14 @@
 {
 	const char *name;
-	const uint8_t *data;
 	size_t packed_size;
-	size_t unpacked_size;
 
 	if (!tar_info(*cstart, cend, &name, &packed_size))
 		return false;
 
-	data = *cstart + TAR_BLOCK_SIZE;
+	const uint8_t *data = *cstart + TAR_BLOCK_SIZE;
 	*cstart += TAR_BLOCK_SIZE + ALIGN_UP(packed_size, TAR_BLOCK_SIZE);
 
-	bool gz = isgzip(name);
-
-	unpacked_size = gz ? gzip_size(data, packed_size) : packed_size;
+	bool gz = gzip_check(data, packed_size);
+	size_t unpacked_size = gz ? gzip_size(data, packed_size) : packed_size;
 
 	/* Components must be page-aligned. */
@@ -156,5 +147,5 @@
 	while (tar_info(start, payload_end, &name, &packed_size)) {
 		sz = ALIGN_UP(sz, PAGE_SIZE);
-		if (isgzip(name))
+		if (gzip_check(start + TAR_BLOCK_SIZE, packed_size))
 			sz += gzip_size(start + TAR_BLOCK_SIZE, packed_size);
 		else
Index: configure.sh
===================================================================
--- configure.sh	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ configure.sh	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -39,5 +39,4 @@
 CONFIG_RULES="${SOURCE_DIR}/HelenOS.config"
 CONFIG_DEFAULTS="${SOURCE_DIR}/defaults"
-
 
 test "$#" -eq 1 && { test "$1" = "-h" || test "$1" = "--help"; }
@@ -85,5 +84,5 @@
 fi
 
-if ! which meson; then
+if ! which meson >/dev/null 2>/dev/null; then
 	echo "Your system does not have Meson installed."
 	echo 'Please use `pip3 install meson`'
@@ -91,5 +90,5 @@
 fi
 
-if ! which ninja; then
+if ! which ninja >/dev/null 2>/dev/null; then
 	echo "Your system does not have ninja installed."
 	echo 'Please use `pip3 install ninja`'
@@ -98,5 +97,7 @@
 
 # Link tools directory for convenience.
-ln -s "${SOURCE_DIR}/tools" tools
+if [ ! -e tools ]; then
+	ln -s "${SOURCE_DIR}/tools" tools
+fi
 
 # Run HelenOS config tool.
@@ -122,25 +123,41 @@
 
 compname="$cc_arch-helenos-gcc"
+unset compprefix
 
-if which "$compname"; then
+if which "$compname" >/dev/null 2>/dev/null; then
 	# Compiler is in PATH
 	compprefix="$cc_arch-helenos-"
 
 elif [ -n "$CROSS_PREFIX" ]; then
-	if ! which "$CROSS_PREFIX/bin/$compname"; then
+	if which "$CROSS_PREFIX/bin/$compname" >/dev/null 2>/dev/null; then
+		compprefix="$CROSS_PREFIX/bin/$cc_arch-helenos-"
+	fi
+
+	if [ -z "$compprefix" ]; then
 		echo "ERROR: \$CROSS_PREFIX defined but $compname is not present in $CROSS_PREFIX/bin."
 		echo "Run tools/toolchain.sh to build cross-compiling toolchain."
 		exit 1
 	fi
+else
+	if [ -z "$XDG_DATA_HOME" ]; then
+			XDG_DATA_HOME="$HOME/.local/share"
+	fi
 
-	compprefix="$CROSS_PREFIX/bin/$cc_arch-helenos-"
-else
-	if ! which "/usr/local/cross/bin/$compname"; then
-		echo "ERROR: \$CROSS_PREFIX is not defined and $compname is not present in /usr/local/cross/bin."
+	if which "$XDG_DATA_HOME/HelenOS/cross/bin/$compname" >/dev/null 2>/dev/null; then
+		compprefix="$XDG_DATA_HOME/HelenOS/cross/bin/$cc_arch-helenos-"
+	elif which "/opt/HelenOS/cross/bin/$compname" >/dev/null 2>/dev/null; then
+		compprefix="/opt/HelenOS/cross/bin/$cc_arch-helenos-"
+	elif which "/usr/local/cross/bin/$compname" >/dev/null 2>/dev/null; then
+		compprefix="/usr/local/cross/bin/$cc_arch-helenos-"
+	fi
+
+	if [ -z "$compprefix" ]; then
+		echo "ERROR: \$CROSS_PREFIX is not defined and $compname is not present in any of the following standard locations."
+		echo " * $XDG_DATA_HOME/HelenOS/cross/bin"
+		echo " * /opt/HelenOS/cross/bin"
+		echo " * /usr/local/cross/bin"
 		echo "Run tools/toolchain.sh to build cross-compiling toolchain."
 		exit 1
 	fi
-
-	compprefix="/usr/local/cross/bin/$cc_arch-helenos-"
 fi
 
Index: contrib/qemu/build-from-scratch.sh
===================================================================
--- contrib/qemu/build-from-scratch.sh	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ contrib/qemu/build-from-scratch.sh	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -29,5 +29,5 @@
 #
 
-VERSION=5.1.0
+VERSION=6.0.0
 BASENAME=qemu-${VERSION}
 BASENAME_MASTER=qemu-master
Index: kernel/arch/amd64/src/amd64.c
===================================================================
--- kernel/arch/amd64/src/amd64.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/arch/amd64/src/amd64.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -224,4 +224,6 @@
 	    ns16550_out_ptr);
 	if (ns16550_instance) {
+		ns16550_format_set(ns16550_instance, 38400,
+		    LCR_PARITY_NONE | LCR_STOP_BIT_TWO | LCR_WORD_LEN_8);
 #ifdef CONFIG_NS16550
 		srln_instance_t *srln_instance = srln_init();
Index: kernel/arch/arm32/include/arch/mm/page.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/page.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/arch/arm32/include/arch/mm/page.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -159,4 +159,7 @@
 #endif
 	TTBR0_write(val);
+#if defined(PROCESSOR_ARCH_armv6) || defined(PROCESSOR_ARCH_armv7_a)
+	BPIALL_write(0);
+#endif
 }
 
Index: kernel/arch/arm32/src/cpu/cpu.c
===================================================================
--- kernel/arch/arm32/src/cpu/cpu.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/arch/arm32/src/cpu/cpu.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -170,6 +170,4 @@
 	 */
 	control_reg |= SCTLR_CACHE_EN_FLAG;
-#endif
-#ifdef PROCESSOR_ARCH_armv7_a
 	/*
 	 * ICache coherency is elaborated on in barrier.h.
Index: kernel/arch/arm32/src/mach/raspberrypi/raspberrypi.c
===================================================================
--- kernel/arch/arm32/src/mach/raspberrypi/raspberrypi.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/arch/arm32/src/mach/raspberrypi/raspberrypi.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -161,5 +161,5 @@
 		spinlock_unlock(&irq->lock);
 	} else {
-		/* Spurious interrupt.*/
+		/* Spurious interrupt. */
 		printf("cpu%d: spurious interrupt (inum=%d)\n", CPU->id, inum);
 		bcm2835_irc_disable(raspi.irc, inum);
@@ -174,6 +174,13 @@
 {
 #ifdef CONFIG_FB
+	uint32_t width, height;
 	fb_properties_t prop;
-	if (bcm2835_fb_init(&prop)) {
+
+	if (!bcm2835_mbox_get_fb_size(&width, &height)) {
+		printf("mbox: could not get the framebuffer size\n");
+		width = 640;
+		height = 480;
+	}
+	if (bcm2835_fb_init(&prop, width, height)) {
 		outdev_t *fb_dev = fb_init(&prop);
 		if (fb_dev)
Index: kernel/arch/ia32/src/ia32.c
===================================================================
--- kernel/arch/ia32/src/ia32.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/arch/ia32/src/ia32.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -209,4 +209,6 @@
 	    ns16550_out_ptr);
 	if (ns16550_instance) {
+		ns16550_format_set(ns16550_instance, 38400,
+		    LCR_PARITY_NONE | LCR_STOP_BIT_TWO | LCR_WORD_LEN_8);
 #ifdef CONFIG_NS16550
 		srln_instance_t *srln_instance = srln_init();
Index: kernel/arch/sparc64/include/arch/sun4v/cpu.h
===================================================================
--- kernel/arch/sparc64/include/arch/sun4v/cpu.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/arch/sparc64/include/arch/sun4v/cpu.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -54,5 +54,5 @@
 	uint64_t cpuids[MAX_CORE_STRANDS];
 	struct cpu *cpus[MAX_CORE_STRANDS];
-	atomic_t nrdy;
+	atomic_size_t nrdy;
 	SPINLOCK_DECLARE(proposed_nrdy_lock);
 } exec_unit_t;
Index: kernel/genarch/include/genarch/drivers/bcm2835/mbox.h
===================================================================
--- kernel/genarch/include/genarch/drivers/bcm2835/mbox.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/genarch/include/genarch/drivers/bcm2835/mbox.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -68,4 +68,11 @@
 
 enum {
+	MBOX_TAG_GET_PHYS_W_H	= 0x00040003,
+	MBOX_TAG_SET_PHYS_W_H	= 0x00048003,
+	MBOX_TAG_GET_VIRT_W_H	= 0x00040004,
+	MBOX_TAG_SET_VIRT_W_G	= 0x00048004
+};
+
+enum {
 	MBOX_PROP_CODE_REQ	= 0x00000000,
 	MBOX_PROP_CODE_RESP_OK	= 0x80000000,
@@ -122,4 +129,14 @@
 
 typedef struct {
+	mbox_prop_buf_hdr_t	buf_hdr;
+	mbox_tag_hdr_t		tag_hdr;
+	struct {
+		uint32_t	width;
+		uint32_t	height;
+	} body;
+	uint32_t zero;
+} mbox_getfbsize_buf_t;
+
+typedef struct {
 	ioport32_t width;
 	ioport32_t height;
@@ -135,5 +152,6 @@
 
 extern bool bcm2835_prop_get_memory(uint32_t *base, uint32_t *size);
-extern bool bcm2835_fb_init(fb_properties_t *prop);
+extern bool bcm2835_fb_init(fb_properties_t *prop, uint32_t width, uint32_t heigth);
+extern bool bcm2835_mbox_get_fb_size(uint32_t *h, uint32_t *w);
 
 #endif
Index: kernel/genarch/include/genarch/drivers/ns16550/ns16550.h
===================================================================
--- kernel/genarch/include/genarch/drivers/ns16550/ns16550.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/genarch/include/genarch/drivers/ns16550/ns16550.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -43,9 +43,25 @@
 #include <console/chardev.h>
 
-#define IER_ERBFI  0x01  /** Enable Receive Buffer Full Interrupt. */
+#define NS156440_CLOCK    115200 /** Internal clock speed, max. baud rate. */
 
-#define LCR_DLAB   0x80  /** Divisor Latch Access bit. */
+#define IER_ERBFI         0x01   /** Enable Receive Buffer Full Interrupt. */
+#define MCR_OUT2          0x08   /** OUT2. */
 
-#define MCR_OUT2   0x08  /** OUT2. */
+#define LCR_DLAB          0x80   /** Divisor Latch Access bit. */
+#define LCR_SBE           0x40   /** RS-232 Break Signal bit. */
+
+#define LCR_PARITY_NONE   0x00   /** No parity bit. */
+#define LCR_PARITY_ODD    0x08   /** Odd parity. */
+#define LCR_PARITY_EVEN   0x18   /** Even parity. */
+#define LCR_PARITY_MARK   0x28   /** Parity bit always one. */
+#define LCR_PARITY_SPACE  0x38   /** Parity bit always zero. */
+
+#define LCR_STOP_BIT_ONE  0x00   /** One stop bit. */
+#define LCR_STOP_BIT_TWO  0x04   /** Two stop bits. */
+
+#define LCR_WORD_LEN_5    0x00   /** 5-bit word length. */
+#define LCR_WORD_LEN_6    0x01   /** 6-bit word length. */
+#define LCR_WORD_LEN_7    0x02   /** 7-bit word length. */
+#define LCR_WORD_LEN_8    0x03   /** 8-bit word length. */
 
 /** NS16550 registers. */
@@ -53,5 +69,7 @@
 	NS16550_REG_RBR = 0,  /**< Receiver Buffer Register (read). */
 	NS16550_REG_THR = 0,  /**< Transmitter Holder Register (write). */
+	NS16550_REG_DLL = 0,  /**< Baud rate divisor latch low byte (write). */
 	NS16550_REG_IER = 1,  /**< Interrupt Enable Register. */
+	NS16550_REG_DLH = 1,  /**< Baud rate divisor latch high byte (write). */
 	NS16550_REG_IIR = 2,  /**< Interrupt Ident Register (read). */
 	NS16550_REG_FCR = 2,  /**< FIFO control register (write). */
@@ -73,4 +91,5 @@
 extern ns16550_instance_t *ns16550_init(ioport8_t *, unsigned, inr_t, cir_t,
     void *, outdev_t **);
+extern void ns16550_format_set(ns16550_instance_t *, unsigned, uint8_t);
 extern void ns16550_wire(ns16550_instance_t *, indev_t *);
 
Index: kernel/genarch/src/drivers/bcm2835/mbox.c
===================================================================
--- kernel/genarch/src/drivers/bcm2835/mbox.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/genarch/src/drivers/bcm2835/mbox.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -86,5 +86,5 @@
 }
 
-bool bcm2835_fb_init(fb_properties_t *prop)
+bool bcm2835_fb_init(fb_properties_t *prop, uint32_t width, uint32_t height)
 {
 	bcm2835_mbox_t *fb_mbox;
@@ -95,6 +95,6 @@
 	    KM_NATURAL_ALIGNMENT, PAGE_NOT_CACHEABLE);
 
-	fb_desc->width = 640;
-	fb_desc->height = 480;
+	fb_desc->width = width;
+	fb_desc->height = height;
 	fb_desc->virt_width = fb_desc->width;
 	fb_desc->virt_height = fb_desc->height;
@@ -128,4 +128,35 @@
 }
 
+bool bcm2835_mbox_get_fb_size(uint32_t *w, uint32_t *h)
+{
+	bool r;
+	MBOX_BUFF_ALLOC(msg, mbox_getfbsize_buf_t);
+	bcm2835_mbox_t *mbox;
+
+	mbox = (void *) km_map(BCM2835_MBOX0_ADDR, sizeof(bcm2835_mbox_t),
+	    KM_NATURAL_ALIGNMENT, PAGE_NOT_CACHEABLE);
+	assert(mbox);
+
+	msg->buf_hdr.size = sizeof(mbox_getfbsize_buf_t);
+	msg->buf_hdr.code = MBOX_PROP_CODE_REQ;
+	msg->tag_hdr.tag_id = MBOX_TAG_GET_PHYS_W_H;
+	msg->tag_hdr.buf_size = sizeof(msg->body);
+	msg->tag_hdr.val_len  = 0;
+	msg->zero = 0;
+
+	mbox_write(mbox,
+	    MBOX_CHAN_PROP_A2V, KA2VCA((uint32_t)msg));
+	mbox_read(mbox, MBOX_CHAN_PROP_A2V);
+
+	r = msg->buf_hdr.code == MBOX_PROP_CODE_RESP_OK;
+	if (r) {
+		*h = msg->body.height;
+		*w = msg->body.width;
+	}
+
+	km_unmap((uintptr_t) mbox, sizeof(bcm2835_mbox_t));
+	return r;
+}
+
 /**
  * @}
Index: kernel/genarch/src/drivers/ega/ega.c
===================================================================
--- kernel/genarch/src/drivers/ega/ega.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/genarch/src/drivers/ega/ega.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -568,15 +568,33 @@
 }
 
-static void ega_redraw(outdev_t *dev)
-{
-	ega_instance_t *instance = (ega_instance_t *) dev->data;
-
-	irq_spinlock_lock(&instance->lock, true);
-
+static void ega_redraw_internal(ega_instance_t *instance)
+{
 	memcpy(instance->addr, instance->backbuf, EGA_VRAM_SIZE);
 	ega_move_cursor(instance);
 	ega_show_cursor(instance);
-
+}
+
+static void ega_redraw(outdev_t *dev)
+{
+	ega_instance_t *instance = (ega_instance_t *) dev->data;
+
+	irq_spinlock_lock(&instance->lock, true);
+	ega_redraw_internal(instance);
 	irq_spinlock_unlock(&instance->lock, true);
+}
+
+/** EGA was mapped or unmapped.
+ *
+ * @param arg EGA instance
+ */
+static void ega_mapped_changed(void *arg)
+{
+	ega_instance_t *instance = (ega_instance_t *) arg;
+
+	if (!instance->parea.mapped) {
+		irq_spinlock_lock(&instance->lock, true);
+		ega_redraw_internal(instance);
+		irq_spinlock_unlock(&instance->lock, true);
+	}
 }
 
@@ -621,4 +639,6 @@
 	instance->parea.unpriv = false;
 	instance->parea.mapped = false;
+	instance->parea.mapped_changed = ega_mapped_changed;
+	instance->parea.arg = (void *) instance;
 	ddi_parea_register(&instance->parea);
 
Index: kernel/genarch/src/drivers/i8042/i8042.c
===================================================================
--- kernel/genarch/src/drivers/i8042/i8042.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/genarch/src/drivers/i8042/i8042.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -77,5 +77,5 @@
 }
 
-/**< Clear input buffer. */
+/** Clear input buffer. */
 static void i8042_clear_buffer(i8042_t *dev)
 {
Index: kernel/genarch/src/drivers/ns16550/ns16550.c
===================================================================
--- kernel/genarch/src/drivers/ns16550/ns16550.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/genarch/src/drivers/ns16550/ns16550.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -132,4 +132,28 @@
 };
 
+/** Configure ns16550 transmission format.
+ *
+ * @param instance   NS 16550 driver instance.
+ * @param baud_rate  Transmission speed in bits per second, also known as baud,
+ *                   maximum value is 115200.
+ * @param lcr_format Line Control Register configuration bits, as defined by
+ *                   the @c LCR_ macros.  These configure the word width,
+ *                   parity type, and stop bit count.
+ */
+void ns16550_format_set(ns16550_instance_t *instance,
+    unsigned baud_rate, uint8_t lcr_format)
+{
+	uint16_t divisor;
+
+	divisor = (uint16_t)(NS156440_CLOCK / baud_rate);
+	if (divisor == 0)
+		divisor = 1;  /* Avoid division by zero. */
+
+	ns16550_reg_write(instance, NS16550_REG_LCR, LCR_DLAB);
+	ns16550_reg_write(instance, NS16550_REG_DLL, divisor & 0xFF);
+	ns16550_reg_write(instance, NS16550_REG_DLH, (divisor >> 8) & 0xFF);
+	ns16550_reg_write(instance, NS16550_REG_LCR, lcr_format & ~LCR_DLAB);
+}
+
 /** Initialize ns16550.
  *
Index: kernel/genarch/src/fb/fb.c
===================================================================
--- kernel/genarch/src/fb/fb.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/genarch/src/fb/fb.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -516,4 +516,19 @@
 }
 
+/** Framebuffer was mapped or unmapped.
+ *
+ * @param arg Framebuffer instance
+ */
+static void fb_mapped_changed(void *arg)
+{
+	fb_instance_t *instance = (fb_instance_t *) arg;
+
+	if (!instance->parea.mapped) {
+		spinlock_lock(&instance->lock);
+		fb_redraw_internal(instance);
+		spinlock_unlock(&instance->lock);
+	}
+}
+
 /** Initialize framebuffer as a output character device
  *
@@ -661,4 +676,6 @@
 	instance->parea.unpriv = false;
 	instance->parea.mapped = false;
+	instance->parea.mapped_changed = fb_mapped_changed;
+	instance->parea.arg = (void *) instance;
 	ddi_parea_register(&instance->parea);
 
Index: kernel/generic/include/adt/hash_table.h
===================================================================
--- kernel/generic/include/adt/hash_table.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/include/adt/hash_table.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -41,4 +41,5 @@
 #include <stdbool.h>
 #include <macros.h>
+#include <member.h>
 
 /** Opaque hash table link type. */
Index: kernel/generic/include/adt/list.h
===================================================================
--- kernel/generic/include/adt/list.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/include/adt/list.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -38,6 +38,9 @@
 
 #include <assert.h>
+#include <macros.h>
+#include <member.h>
 #include <stdbool.h>
 #include <stddef.h>
+#include <stdint.h>
 #include <trace.h>
 
@@ -89,8 +92,8 @@
 
 #define list_get_instance(link, type, member) \
-	((type *) (((void *)(link)) - list_link_to_void(&(((type *) NULL)->member))))
+	member_to_inst(link, type, member)
 
 #define list_foreach(list, member, itype, iterator) \
-	for (itype *iterator = NULL; iterator == NULL; iterator = (itype *) 1) \
+	for (itype *iterator = NULL; iterator == NULL; iterator = (itype *) sizeof(itype)) \
 		for (link_t *_link = (list).head.next; \
 		    iterator = list_get_instance(_link, itype, member), \
@@ -98,5 +101,5 @@
 
 #define list_foreach_rev(list, member, itype, iterator) \
-	for (itype *iterator = NULL; iterator == NULL; iterator = (itype *) 1) \
+	for (itype *iterator = NULL; iterator == NULL; iterator = (itype *) sizeof(itype)) \
 		for (link_t *_link = (list).head.prev; \
 		    iterator = list_get_instance(_link, itype, member), \
@@ -375,7 +378,7 @@
  *
  */
-static inline link_t *list_nth(const list_t *list, unsigned long n)
-{
-	unsigned long cnt = 0;
+static inline link_t *list_nth(const list_t *list, size_t n)
+{
+	size_t cnt = 0;
 
 	link_t *link = list_first(list);
@@ -391,13 +394,4 @@
 }
 
-/** Verify that argument type is a pointer to link_t (at compile time).
- *
- * This can be used to check argument type in a macro.
- */
-static inline const void *list_link_to_void(const link_t *link)
-{
-	return link;
-}
-
 /** Determine if link is used.
  *
Index: kernel/generic/include/adt/odict.h
===================================================================
--- kernel/generic/include/adt/odict.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/include/adt/odict.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -37,4 +37,5 @@
 
 #include <errno.h>
+#include <member.h>
 #include <stdbool.h>
 #include <stddef.h>
@@ -42,5 +43,5 @@
 
 #define odict_get_instance(odlink, type, member) \
-	((type *)( (void *)(odlink) - ((void *) &((type *) NULL)->member)))
+	member_to_inst(odlink, type, member)
 
 extern void odict_initialize(odict_t *, odgetkey_t, odcmp_t);
Index: kernel/generic/include/atomic.h
===================================================================
--- kernel/generic/include/atomic.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/include/atomic.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -40,13 +40,4 @@
 #include <stdatomic.h>
 
-// TODO: Remove.
-// Before <stdatomic.h> was available, there was only one atomic type
-// equivalent to atomic_size_t. This means that in some places, atomic_t can
-// be replaced with a more appropriate type (e.g. atomic_bool for flags or
-// a signed type for potentially signed values).
-// So atomic_t should be replaced with the most appropriate type on a case by
-// case basis, and after there are no more uses, remove this type.
-typedef atomic_size_t atomic_t;
-
 #define atomic_predec(val) \
 	(atomic_fetch_sub((val), 1) - 1)
Index: kernel/generic/include/cap/cap.h
===================================================================
--- kernel/generic/include/cap/cap.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/include/cap/cap.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -80,5 +80,5 @@
 typedef struct kobject {
 	kobject_type_t type;
-	atomic_t refcnt;
+	atomic_size_t refcnt;
 
 	/** Mutex protecting caps_list */
Index: kernel/generic/include/cpu.h
===================================================================
--- kernel/generic/include/cpu.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/include/cpu.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -58,5 +58,5 @@
 	context_t saved_context;
 
-	atomic_t nrdy;
+	atomic_size_t nrdy;
 	runq_t rq[RQ_COUNT];
 	volatile size_t needs_relink;
Index: kernel/generic/include/ddi/ddi.h
===================================================================
--- kernel/generic/include/ddi/ddi.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/include/ddi/ddi.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -42,5 +42,5 @@
 
 /** Structure representing contiguous physical memory area. */
-typedef struct {
+typedef struct parea {
 	/** Link to @c pareas ordered dictionary */
 	odlink_t lpareas;
@@ -54,4 +54,8 @@
 	/** Indicate whether the area is actually mapped. */
 	bool mapped;
+	/** Called when @c mapped field has changed */
+	void (*mapped_changed)(void *);
+	/** Callback argument */
+	void *arg;
 } parea_t;
 
@@ -59,4 +63,5 @@
 extern void ddi_parea_init(parea_t *);
 extern void ddi_parea_register(parea_t *);
+extern void ddi_parea_unmap_notify(parea_t *);
 
 extern void *pio_map(void *, size_t);
Index: kernel/generic/include/halt.h
===================================================================
--- kernel/generic/include/halt.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/include/halt.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -38,5 +38,5 @@
 #include <atomic.h>
 
-extern atomic_t haltstate;
+extern atomic_bool haltstate;
 
 extern void halt(void) __attribute__((noreturn));
Index: kernel/generic/include/ipc/ipc.h
===================================================================
--- kernel/generic/include/ipc/ipc.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/include/ipc/ipc.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -71,5 +71,5 @@
 	struct call *hangup_call;
 	ipc_phone_state_t state;
-	atomic_t active_calls;
+	atomic_size_t active_calls;
 	/** User-defined label */
 	sysarg_t label;
@@ -90,5 +90,5 @@
 	 * Number of answers the answerbox is expecting to eventually arrive.
 	 */
-	atomic_t active_calls;
+	atomic_size_t active_calls;
 
 	/** Phones connected to this answerbox. */
Index: kernel/generic/include/macros.h
===================================================================
--- kernel/generic/include/macros.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/include/macros.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -160,8 +160,4 @@
 	})
 
-#define member_to_inst(ptr_member, type, member_identif) \
-	((type *) (((void *) (ptr_member)) - \
-	    ((void *) &(((type *) 0)->member_identif))))
-
 /** Get the size of an array in array elements
  *
Index: kernel/generic/include/member.h
===================================================================
--- kernel/generic/include/member.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ kernel/generic/include/member.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,47 @@
+/*
+ * Copyright (c) 2021 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kernel_generic
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_MEMBER_H_
+#define KERN_MEMBER_H_
+
+#include <stdint.h>
+
+#define member_to_inst(ptr_member, type, member_identif) \
+	((type *) (((uintptr_t) (ptr_member)) - \
+	    offsetof(type, member_identif)))
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/mm/as.h
===================================================================
--- kernel/generic/include/mm/as.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/include/mm/as.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -236,4 +236,5 @@
 		size_t frames;
 		bool anonymous;
+		struct parea *parea;
 	};
 
Index: kernel/generic/include/mm/slab.h
===================================================================
--- kernel/generic/include/mm/slab.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/include/mm/slab.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -99,9 +99,9 @@
 
 	/* Statistics */
-	atomic_t allocated_slabs;
-	atomic_t allocated_objs;
-	atomic_t cached_objs;
+	atomic_size_t allocated_slabs;
+	atomic_size_t allocated_objs;
+	atomic_size_t cached_objs;
 	/** How many magazines in magazines list */
-	atomic_t magazine_counter;
+	atomic_size_t magazine_counter;
 
 	/* Slabs */
Index: kernel/generic/include/proc/scheduler.h
===================================================================
--- kernel/generic/include/proc/scheduler.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/include/proc/scheduler.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -52,5 +52,5 @@
 } runq_t;
 
-extern atomic_t nrdy;
+extern atomic_size_t nrdy;
 extern void scheduler_init(void);
 
Index: kernel/generic/include/proc/task.h
===================================================================
--- kernel/generic/include/proc/task.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/include/proc/task.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -87,7 +87,7 @@
 
 	/** Number of references (i.e. threads). */
-	atomic_t refcount;
+	atomic_size_t refcount;
 	/** Number of threads that haven't exited yet. */
-	atomic_t lifecount;
+	atomic_size_t lifecount;
 
 	/** Task permissions. */
